@echo off
set dolink=yes
set docode=no
set dolist=no

:parseargs
if "%1"=="" goto help
if "%1"=="/?" goto help
if "%1"=="/h" goto help
if "%1"=="/H" goto help
if "%1"=="-h" goto help
if "%1"=="-H" goto help
if "%1"=="/c" goto setlink
if "%1"=="-c" goto setlink
if "%1"=="/Fc" goto setcode
if "%1"=="-Fc" goto setcode
if "%1"=="/Fs" goto setlist
if "%1"=="-Fs" goto setlist
rem here it must be a filename
goto compile
:setlink
set dolink=no
shift
goto parseargs
:setcode
set docode=yes
shift
goto parseargs
:setlist
set dolist=yes
shift
goto parseargs

:compile
if not exist %1.imp goto nosource

rem set up our files

set codefile=NUL
if "%docode%"=="yes" set codefile=%1.cod
set listfile=NUL
if "%dolist%"=="yes" set listfile=%1.lst

i32p1 %1.imp,c:\imp32\stdperm.imp/%1.icd:b,%listfile%
if errorlevel 1 goto end

i32p2 %1.icd:b,%1.imp/%1.ibj,%codefile%
del %1.icd
i32p3 %1.ibj %1.obj
del %1.ibj

if "%dolink%"=="no" goto end
link /nologo /stack:80000,80000 %1 libi77.lib
del %1.obj
goto end

:nosource
echo Source file not found?

:help
echo Usage: I77 [-c] [-Fc] [-Fs] basename
echo where basename is the source file (without .IMP extension)
echo       -c       inhibits the link phase
echo       -Fc      produces a .COD file with interleaved source and assembler
echo       -Fs      produces a .LST source listing file

:end
